
#ifndef ANATOMY_H
#define ANATOMY_H

#include "generalization.h"
#include "set.h"
#include "signature.h"
#include "mechDistortion.h"
#include "calViolation.h"
#include "ass.h"

void anatomy_main(data *aData, configure *config, generalizedAllTable *genAllTable);
equivalenceClass *anatomy_main_output(data *aData, configure *config, generalizedAllTable *genAllTable);
int anatomy_findNoOfEqTupleWithSenValue(equivalenceClass *eqClass, int senIndex);
int anatomy_findNoOfViolateEqTuple(equivalenceClass *eqClass, int senIndex, signatureGroupGroupGroup *allSig, int ***allSigMapping, int m, int noOfTuple);
int anatomy_findNoOfEqTupleWithSenIndex_considerNewSen(equivalenceClass *eqClass, int senIndex, configure *config);
int anatomy_findNoOfEqTupleWithSenIndex(equivalenceClass *eqClass, int senIndex);

#endif

