/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : create a matrix.                                                   */
/* see   : create_mR.c (m01.zip)                                              */
/* -------------------------------------------------------------------------- */
MAT_TYPE * create_mR(
int row,
int col)
{
MAT_TYPE *PmA;

 PmA = (MAT_TYPE *) malloc(row* col* sizeof(MAT_TYPE));

 if(PmA==NULL){ printf("create_mR:Insufficient memory!\n"); //exit(1);
 }

 return(PmA);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : create and initialize a matrix at 0.                               */
/* see   : init_mR.c (m01.zip)                                                */
/* -------------------------------------------------------------------------- */
MAT_TYPE * init_mR(
int row,
int col)
{
MAT_TYPE *PmA;

 PmA = (MAT_TYPE *) calloc(row*col, sizeof(MAT_TYPE));

 if(PmA==NULL){printf("init_mR:Insufficient memory!\n"); //exit(1);
 }

 return(PmA);
}

