/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_A_R(
PmR mA,
PmR mU,
PmR mV
)
{
MAT_TYPE InnerProduct;

//MAT_TYPE pTrposA [MXR][MXC];
//mR mTrposA ={MXR,MXC,&pTrposA [0][0]};
//MAT_TYPE pTrposAA[MXR][MXC];
//mR mTrposAA={MXR,MXC,&pTrposAA[0][0]};
//MAT_TYPE pTrposV [MXR][MXC];
//mR mTrposV ={MXR,MXC,&pTrposV [0][0]};

mR mTrposA;
mR mTrposAA;
mR mTrposV;

//MAT_TYPE pTrposV_TrposAA[MXR][MXC];
//mR mTrposV_TrposAA ={MXR,MXC,&pTrposV_TrposAA[0][0]};

mR mTrposV_TrposAA;

//MAT_TYPE pTrposV_TrposAA__U[MXR][MXC];
//mR mTrposV_TrposAA__U ={MXR,MXC,&pTrposV_TrposAA__U[0][0]};

mR mTrposV_TrposAA__U;

             mTrposA.rows =   mA->rows;               mTrposA.cols = mA->cols;
            mTrposAA.rows =   mA->rows;              mTrposAA.cols = mA->cols;
             mTrposV.rows =   mV->cols;             mTrposV.cols = mV->rows;
     mTrposV_TrposAA.rows =   mV->cols;     mTrposV_TrposAA.cols = mA->cols;
  mTrposV_TrposAA__U.rows =   mV->cols;  mTrposV_TrposAA__U.cols = mU->cols;

	mTrposA.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposA.rows*mTrposA.cols);
	mTrposAA.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposAA.rows*mTrposAA.cols);
	mTrposV.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV.rows*mTrposV.cols);
	mTrposV_TrposAA.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV_TrposAA.rows*mTrposV_TrposAA.cols);
	mTrposV_TrposAA__U.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV_TrposAA__U.rows*mTrposV_TrposAA__U.cols);


            transpose_mR(mA,&mTrposA);
                 mul_mR(   &mTrposA,mA,&mTrposAA);

            transpose_mR(mV,&mTrposV);
                 mul_mR(   &mTrposV,&mTrposAA,&mTrposV_TrposAA);

                 mul_mR(&mTrposV_TrposAA,mU,&mTrposV_TrposAA__U);

       InnerProduct = *(mTrposV_TrposAA__U.pb+0 *mTrposV_TrposAA__U.cols+0  );

	free(mTrposA.pb);
	free(mTrposAA.pb);
	free(mTrposV.pb);
	free(mTrposV_TrposAA.pb);
	free(mTrposV_TrposAA__U.pb);

 return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE normP2_A_R(
PmR mA,
PmR mu
)
{
MAT_TYPE NormP2;

         NormP2 = innerprod_A_R(mA,mu,mu);

  return(NormP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE distanceP2_A_R(
PmR mA,
PmR mu,
PmR mv
)
{
MAT_TYPE DistanceP2;

//MAT_TYPE pu_mns_v [MXR][MXC];
//mR mu_mns_v={MXR, MXC,&pu_mns_v[0][0]};
mR mu_mns_v;

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

	   mu_mns_v.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mu->rows*mu->cols);

      sub_mR(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_A_R(mA,&mu_mns_v);

  free(mu_mns_v.pb);

  return(DistanceP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_A(
PmR mA,
PmR mu,
PmR mv,
PmR mvn
)
{
MAT_TYPE InnerProduv;
MAT_TYPE     NormvP2;
MAT_TYPE   InvNormP2;
MAT_TYPE InnerProduv_InvNormP2;
/*-------------------------------- PROGRAM ---------------------------------- */
             InnerProduv = innerprod_A_R(mA,mu,mv);
                 NormvP2 =    normP2_A_R(mA,mv);
  if(!NormvP2)
    {
     printf("\n projwn_A() error - 1/0");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }
               InvNormP2 =    (MAT_TYPE)    (1./NormvP2);

   InnerProduv_InvNormP2 =  (InnerProduv*InvNormP2);

        smul_mR(InnerProduv_InvNormP2,mv,mvn);
}
