/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_Mnm_R(
PmR mU,
PmR mV
)
{
MAT_TYPE InnerProduct;

//MAT_TYPE pTrposU   [MXR][MXC];
//mR mTrposU   ={MXR,MXC,&pTrposU   [0][0]};
//MAT_TYPE pTrposU_V [MXR][MXC];
//mR mTrposU_V ={MXR,MXC,&pTrposU_V [0][0]};

mR mTrposU;
mR mTrposU_V;


             mTrposU.rows =   mU->cols;       mTrposU.cols = mU->rows;
           mTrposU_V.rows = mTrposU.rows;     mTrposU_V.cols = mV->cols;

		   mTrposU.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposU.rows*mTrposU.cols);
		   mTrposU_V.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposU_V.rows*mTrposU_V.cols);

            transpose_mR(mU,&mTrposU);
                 mul_mR(   &mTrposU,mV,&mTrposU_V);
  InnerProduct= trace_mR(               &mTrposU_V);

  free(mTrposU.pb);
  free(mTrposU_V.pb);

 return(InnerProduct);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE normP2_Mnm_R(
PmR mu
)
{
MAT_TYPE NormP2;

         NormP2 = innerprod_Mnm_R(mu,mu);

  return(NormP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE distanceP2_Mnm_R(
PmR mu,
PmR mv
)
{
MAT_TYPE DistanceP2;

//MAT_TYPE pu_mns_v [MXR][MXC];
//mR mu_mns_v={MXR, MXC,&pu_mns_v[0][0]};
mR mu_mns_v;

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;
		
	   mu_mns_v.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mu_mns_v.rows*mu_mns_v.cols);


      sub_mR(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_Mnm_R(&mu_mns_v);

  free(mu_mns_v.pb);

  return(DistanceP2);
}



/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_Mnm(
PmR mu,
PmR mv,
PmR mvn
)
{
MAT_TYPE InnerProduv;
MAT_TYPE     NormvP2;
MAT_TYPE   InvNormP2;
MAT_TYPE InnerProduv_InvNormP2;
/*-------------------------------- PROGRAM ---------------------------------- */
             InnerProduv = innerprod_Mnm_R(mu,mv);

                 NormvP2 =    normP2_Mnm_R(   mv);
  if(!NormvP2)
    {
     printf("\n projwn_Mnm() error - 1/0");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }
               InvNormP2 =    (MAT_TYPE)    (1./NormvP2);
   InnerProduv_InvNormP2 =  (InnerProduv*InvNormP2);

        smul_mR(InnerProduv_InvNormP2,mv,mvn);
}
