/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_W_R(
PmR mA,
PmR mU,
PmR mV
)
{
MAT_TYPE InnerProduct;

//MAT_TYPE pTrposV [MXR][MXC];
//mR mTrposV ={MXR,MXC,&pTrposV [0][0]};

//MAT_TYPE pTrposV_A[MXR][MXC];
//mR mTrposV_A ={MXR,MXC,&pTrposV_A[0][0]};

//MAT_TYPE pTrposV_A__U[MXR][MXC];
//mR mTrposV_A__U ={MXR,MXC,&pTrposV_A__U[0][0]};

mR mTrposV;
mR mTrposV_A;
mR mTrposV_A__U;


             mTrposV.rows =  mV->cols;        mTrposV.cols = mV->rows;
           mTrposV_A.rows =  mV->cols;      mTrposV_A.cols = mA->cols;
        mTrposV_A__U.rows =  mV->cols;   mTrposV_A__U.cols = mU->cols;

		mTrposV.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV.rows*mTrposV.cols);
		mTrposV_A.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV_A.rows*mTrposV_A.cols);
		mTrposV_A__U.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrposV_A__U.rows*mTrposV_A__U.cols);


            transpose_mR(mV,&mTrposV);
                 mul_mR(   &mTrposV,mA,&mTrposV_A);

                 mul_mR(&mTrposV_A,mU,&mTrposV_A__U);

       InnerProduct = *(mTrposV_A__U.pb+0  *mTrposV_A__U.cols+0  );

		free(mTrposV.pb);
		free(mTrposV_A.pb);
		free(mTrposV_A__U.pb);

 return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE normP2_W_R(
PmR mA,
PmR mu
)
{
MAT_TYPE NormP2;

         NormP2 = innerprod_W_R(mA,mu,mu);

  return(NormP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */


/* -------------------------------------------------------------------------- */
MAT_TYPE distanceP2_W_R(
PmR mA,
PmR mu,
PmR mv
)
{
MAT_TYPE DistanceP2;

//MAT_TYPE pu_mns_v [MXR][MXC];
//mR mu_mns_v={MXR, MXC,&pu_mns_v[0][0]};
mR mu_mns_v;

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

	   mu_mns_v.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mu_mns_v.rows*mu_mns_v.cols);

      sub_mR(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_W_R(mA,&mu_mns_v);

  free(mu_mns_v.pb);

  return(DistanceP2);
}



