/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_mR_c(
PmR mA,
char name[9])
{
 int i;
 int j;

 printf("MAT_TYPE pb%s[%d][%d]=\n",name, mA->rows, mA->cols);
 printf("{");

 for (i = 0 ; i < mA->rows ; i++)
  {
   printf("\n");
   for ( j = 0 ; j < mA->cols ; j++)
     printf(" %+6.5f, ",*(mA->pb+i *mA->cols+j  ));
  }

 printf("\n};\n");
 printf(" mR %s={%d,%d,&pb%s[0][0]};\n",name,mA->rows,mA->cols,name);

 printf("\n");
}



/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_mR_cn(
PmR mA,
char name[9],
int n)
{
 int i;
 int j;

 printf("MAT_TYPE pb%s%d[%d][%d]=\n",name,n, mA->rows, mA->cols);
 printf("{");

 for (i = 0 ; i < mA->rows ; i++)
  {
   printf("\n");
   for ( j = 0 ; j < mA->cols ; j++)
     printf(" %+6.5f, ",*(mA->pb+i *mA->cols+j  ));
  }

 printf("\n};\n");
 printf(" mR %s%d={%d,%d,&pb%s%d[0][0]};\n",name,n,mA->rows,mA->cols,name,n);

 printf("\n");
}

