/* yrvlc.h           freeware           http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commute_mR(
PmR sinA,
PmR cosA,
int    i
)
{
   int n;
MAT_TYPE det;

//MAT_TYPE pbA       [MXR][MXC];
//mR A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mR P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mR InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mR D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mR sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mR cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mR T        ={MXR,MXC,&pbT       [0][0]};

mR A;
mR P;
mR InvP;
mR D;
mR sinD;
mR cosD;
mR T;

                                 n = sinA->rows;
                     A.rows= n;                     A.cols= n;
                     P.rows= n;                     P.cols= n;
                  InvP.rows= n;                  InvP.cols= n;
                     D.rows= n;                     D.cols= n;
                  sinD.rows= n;                  sinD.cols= n;
                  cosD.rows= n;                  cosD.cols= n;
                     T.rows= n;                     T.cols= n;

					 A.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
               rnd_mR(&P,i);
          det = (MAT_TYPE) det_R(&P);
  }while(!det);

  rnd_diag_mR(&D,i);
  inverse_mR(&P,&InvP);
  mul_mR(&P, &D,    &T);
  mul_mR(&T, &InvP, &A);
  zeros_mR(&cosD);
  zeros_mR(&sinD);

  mul_mR(&A,&P,&T);          /*  invP A P = D : (eigenvalues on the diagonal) */
  mul_mR(&InvP,&T,&D);
  diag_cos_mR(&D,&cosD);     /*        cos(D)                                 */
  mul_mR(&P,&cosD,&T);       /*  P cos(D) invP = cos(A)                       */
  mul_mR(&T,&InvP,cosA);

  clrscrn();
  diag_sin_mR(&D,&sinD);     /*        sin(D)                                 */
  mul_mR(&P,&sinD,&T);       /*  P sin(D) invP = sin(A)                       */
  mul_mR(&T,&InvP,sinA);

					free(A.pb);
					 free(P.pb);
					 free(InvP.pb);
					 free(D.pb);
					 free(sinD.pb);
					 free(cosD.pb);
					 free(T.pb);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commuteh_mR(
PmR sinhA,
PmR coshA,
int    i
)
{
   int n;
MAT_TYPE det;

//MAT_TYPE pbA       [MXR][MXC];
//mR A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mR P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mR InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mR D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mR sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mR cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mR T        ={MXR,MXC,&pbT       [0][0]};

mR A;
mR P;
mR InvP;
mR D;
mR sinD;
mR cosD;
mR T;

                                 n = sinhA->rows;
                     A.rows= n;                     A.cols= n;
                     P.rows= n;                     P.cols= n;
                  InvP.rows= n;                  InvP.cols= n;
                     D.rows= n;                     D.cols= n;
                  sinD.rows= n;                  sinD.cols= n;
                  cosD.rows= n;                  cosD.cols= n;
                     T.rows= n;                     T.cols= n;

					 A.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
               rnd_mR(&P,i);
          det = det_R(&P);
  }while(!det);

  rnd_diag_mR(&D,i);
  inverse_mR(&P,&InvP);
  mul_mR(&P, &D,    &T);
  mul_mR(&T, &InvP, &A);
  zeros_mR(&cosD);
  zeros_mR(&sinD);

  mul_mR(&A,&P,&T);           /* invP A P = D : (eigenvalues on the diagonal) */
  mul_mR(&InvP,&T,&D);
  diag_cosh_mR(&D,&cosD);     /*        cosh(D)                               */
  mul_mR(&P,&cosD,&T);        /*  P cosh(D) invP = cos(A)                     */
  mul_mR(&T,&InvP,coshA);

  clrscrn();
  diag_sinh_mR(&D,&sinD);     /*        sinh(D)                               */
  mul_mR(&P,&sinD,&T);        /*  P sinh(D) invP = sinh(A)                    */
  mul_mR(&T,&InvP,sinhA);

					 free(A.pb);
					 free(P.pb);
					 free(InvP.pb);
					 free(D.pb);
					 free(sinD.pb);
					 free(cosD.pb);
					 free(T.pb);
}


