/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_mR(
PmR  mA,
int  n)
{
int      i;
int      j;
//*** Ray modified
//MAT_TYPE f;

  for  (i=0; i<mA->rows; i++)
    for(j=0; j<mA->cols; j++)
        *(mA->pb+i *mA->cols+j)= (MAT_TYPE) rnd_I(n);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rndp_mR(
PmR  mA,
int  n)
{
int      i;
int      j;
//*** Ray modified
//MAT_TYPE f;

  for  (i=0; i<mA->rows; i++)
    for(j=0; j<mA->cols; j++)
        *(mA->pb+i *mA->cols+j)= (MAT_TYPE) rndp_I(n);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd0_mR(
PmR mA,
int n)
{
int i;
int j;

  for (   i=0 ; i<mA->rows ; i++)
    for ( j=0 ; j<mA->cols ; j++)
        *(mA->pb+i *mA->cols+j)   = (MAT_TYPE) rnd0_I(n);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_cr_sumless1_mR(
PmR  mA,
int  n)
{
int      i;
int      j;
//*** Ray modified
//MAT_TYPE f;

  for  (i=0; i<mA->rows; i++)
    for(j=0; j<mA->cols; j++)
        *(mA->pb+i *mA->cols+j)= (MAT_TYPE) 1./((rndp_I(n)*3));
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_orth_mR(
PmR mA,
int max
)
{
     int        n;
MAT_TYPE       Norm;
MAT_TYPE    InvNorm;
MAT_TYPE Two = 2;


//MAT_TYPE pbID    [MXR][MXC];
//mR mID     ={MXR,MXC,&pbID    [0][0]};
//MAT_TYPE pbx     [MXR][MXC];
//mR mx      ={MXR,MXC,&pbx     [0][0]};
//MAT_TYPE pTrpsx  [MXR][MXC];
//mR mTrpsx  ={MXR,MXC,&pTrpsx  [0][0]};
//MAT_TYPE px_Trpsx[MXR][MXC];
//mR mx_Trpsx={MXR,MXC,&px_Trpsx[0][0]};

//MAT_TYPE pInvNorm_mx_Trpsx [MXR][MXC];
//mR mInvNorm_mx_Trpsx={MXR, MXC,&pInvNorm_mx_Trpsx[0][0]};

mR mID;
mR mx;
mR mTrpsx;
mR mx_Trpsx;
mR mInvNorm_mx_Trpsx;

                                   n = mA->rows;
                    mID.rows= n;                    mID.cols= n;
                     mx.rows= n;                     mx.cols=   1;
                 mTrpsx.rows= 1;                 mTrpsx.cols= n;
               mx_Trpsx.rows= n;               mx_Trpsx.cols= n;
      mInvNorm_mx_Trpsx.rows= n;      mInvNorm_mx_Trpsx.cols= n;

		mID.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mID.rows*mID.cols);
		mx.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mx.rows*mx.cols);
		mTrpsx.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsx.rows*mTrpsx.cols);
		mx_Trpsx.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mx_Trpsx.rows*mx_Trpsx.cols);
		mInvNorm_mx_Trpsx.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mInvNorm_mx_Trpsx.rows*mInvNorm_mx_Trpsx.cols);

/*-------------------------------- PROGRAM ---------------------------------- */
  rnd_mR(&mx,max);
    eye_mR(&mID);

     Norm = (MAT_TYPE) normP2_R(&mx);

  if(!Norm)
    {
     printf("\n rnd_orth_mR() error - 1/0");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  InvNorm = (Two*(1/Norm));

  transpose_mR(&mx,&mTrpsx);
       mul_mR(&mx,&mTrpsx,&mx_Trpsx);

  smul_mR(InvNorm,&mx_Trpsx,&mInvNorm_mx_Trpsx);
    sub_mR(&mID,             &mInvNorm_mx_Trpsx, mA);
    swap_c_R( mA,((mA->cols)-1),1);
    swap_r_R( mA,( mA->rows -1),0);

		free(mID.pb);
		free(mx.pb);
		free(mTrpsx.pb);
		free(mx_Trpsx.pb);
		free(mInvNorm_mx_Trpsx.pb);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :   vectab.zip   pythgI.c                                            */
/* -------------------------------------------------------------------------- */
void rnd_ortho_uv_R(
PmR mu,
PmR mv,
    int n)
{
     int i;
     int j;
MAT_TYPE InnerProduct;

   rnd_mR(mu,n);
   rnd_mR(mv,n);

       i = mu->rows - 1;
       j = mu->cols - 1;

     *(mu->pb+i *mu->cols+j    ) = 0;
     *(mv->pb+i *mv->cols+j    ) = 1;

   InnerProduct = innerprod_R(mu,mv);

     *(mu->pb+i *mu->cols+j    ) = (MAT_TYPE) -InnerProduct;
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_dR(
PmR  mA,
int  Stem,
int  n)
{
int    i;
int    j;

  for  (i=0; i<mA->rows; i++)
    for(j=0; j<mA->cols; j++)
        *(mA->pb+i *mA->cols+j)=(MAT_TYPE) (Stem*10)+rndp_I(n);
}

