/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void p_innerprod_r_mZ(
PmZ mv,
char c
)
{
complexZ f;
int i;
int j;

MAT_TYPE pbvT[MXR][MXC*C2];mZ mvT ={MXR,MXC*C2,&pbvT[0][0]};
MAT_TYPE pvnT[MXR][MXC*C2];mZ mvnT={MXR,MXC*C2,&pvnT[0][0]};

   mvT.rows = 1;          mvT.cols = mv->cols;
  mvnT.rows = 1;         mvnT.cols = mv->cols;

for(i = 0; i < (mv->rows) ; i++)
   {
   for(j = 1; j < (mv->rows) ; j++)
     {
      copy_r_Z(mv,i,&mvT, 0);
      copy_r_Z(mv,j,&mvnT,0);

      f = innerprod_Z(&mvT,&mvnT);
      if(!(i==j || i>j))
        {
         printf(" %c%d.%c%d=",c,i+1,c,j+1);p_Z(f);
        }
     }
   printf("\n");
   }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void p_innerprod_c_mZ(
PmZ mv,
char c
)
{
MAT_TYPE pbv_T[MXR][MXC*C2];mZ mv_T ={MXR,MXC*C2,&pbv_T[0][0]};

        mv_T.rows = (mv->cols)/C2; mv_T.cols = (mv->rows)*C2;

     transpose_mZ(mv,&mv_T);
 p_innerprod_r_mZ(   &mv_T,c);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_norm_r_mZ(
PmZ mu,
char c
)
{
complexZ z;
int i;

MAT_TYPE pbT[MXR][MXC]; mZ mT ={MXR,MXC,&pbT[0][0]};

    mT.rows = 1;          mT.cols = mu->cols;

  for(i = 0; i<(mu->rows); i++)
   {
    copy_r_Z(mu,i,&mT, 0);
    z = innerprod_Z(&mT,&mT);
    printf("  ||%c%d|| =",c,i+1);p_Z(z);
    printf("\n");
   }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void p_norm_c_mZ(
PmZ mv,
char c
)
{
MAT_TYPE pbv_T[MXR][MXC*C2];mZ mv_T ={MXR,MXC*C2,&pbv_T[0][0]};

        mv_T.rows = (mv->cols)/C2; mv_T.cols = (mv->rows)*C2;

     transpose_mZ(mv,&mv_T);
      p_norm_r_mZ(   &mv_T,c);
}

