
#include "differentiation.h"

int term_isExist(term *aTerm, int diffIndexNo)
{
	int isExist;

	int i;

	int noOfOperand;
	term **operandList;

	//term *aTerm1;
	literal *aLiteral1;

	noOfOperand = aTerm->noOfOperand;
	operandList = aTerm->operandList;

	if (noOfOperand == 0)
	{
		isExist = 0;
	}
	else if (noOfOperand == 1)
	{
		aLiteral1 = aTerm->aLiteral;
		if ((aLiteral1->isConstant == 0) && (aLiteral1->value == diffIndexNo))
		{
			isExist = 1;
		}
		else
		{
			isExist = 0;
		}
	}
	else
	{
		isExist = 0;
		for (i = 0; i < noOfOperand; i++)
		{
			isExist = term_isExist(operandList[i], diffIndexNo);
			if (isExist == 1)
			{
				break;
			}
			//aTerm1 = operandList[i];
			//aLiteral1 = term_getLiteral(aTerm1);

			//if (aLiteral1->isConstant != 1)
			//{
			//	if (aLiteral1->value == diffIndexNo)
			//	{
			//		isExist = 1;
			//		break;
			//	}
			//}
		}
	}

	return isExist;
}

int term_isConstantMultiplyDivision(term *aTerm)
{
	int returnValue;

	int noOfOperand;
	term **operandList;
	int *operationList;

	term *firstTerm;
	term *secondTerm;

	noOfOperand = aTerm->noOfOperand;
	operandList = aTerm->operandList;
	operationList = aTerm->operationList;

	if (noOfOperand == 2)
	{
		if (operationList[0] == OP_MULT)
		{
			firstTerm = operandList[0];

			if ((firstTerm->noOfOperand == 1) && (firstTerm->aLiteral->isConstant == 1))
			{
				secondTerm = operandList[1];
				if ((secondTerm->noOfOperand == 2) && (secondTerm->operationList[0] == OP_DIVIDE))
				{
					returnValue = 1;
				}
				else
				{
					returnValue = 0;
				}
			}
			else
			{
				returnValue = 0;
			}
		}
		else
		{
			returnValue = 0;
		}
	}
	else
	{
		returnValue = 0;
	}


	return returnValue;
}

// only works for our special case
term *term_differentiateMultiplication(term *aTerm, int diffIndexNo)
{
	term *returnValue;

	int noOfOperand;
	term **operandList;

	literal *aLiteral1;
	literal *aSingleLiteral;
	literal *aSingleLiteralConst;

	term *aTerm1;
	term *aSingleTerm;
	term *aSingleTermConst;

	term **oldList;
	int finalTotalNoOfOperand;

	int i;
	int isExist;

	int offsetConst;
	int offsetExponent;

	term **oldOperandList;

	term *secondTerm;

	int isConstantMultiplyDivision;


	returnValue = term_new();

	noOfOperand = aTerm->noOfOperand;
	operandList = aTerm->operandList;

	// malloc
	returnValue->operandList = (term **) malloc(sizeof(term *)*(noOfOperand+1));
	for (i = 0; i < noOfOperand+1; i++)
	{
		returnValue->operandList[i] = term_new();
	}
	aSingleTerm = returnValue->operandList[0];
	aSingleLiteral = literal_new(); //term_getLiteral(aSingleTerm);
	aSingleLiteral->isConstant = 1;
	aSingleLiteral->value = 1;

	aSingleTerm->aLiteral = aSingleLiteral;
	aSingleTerm->noOfOperand = 1;

	// isExist?

	isExist = term_isExist(aTerm, diffIndexNo);


	if (isExist == 1)
	{
		isConstantMultiplyDivision = term_isConstantMultiplyDivision(aTerm);
		if (isConstantMultiplyDivision == 1)
		{
			aLiteral1 = aTerm->operandList[0]->aLiteral;
			aSingleLiteral->value = aLiteral1->value;

			//term_free(returnValue->operandList[1]);
			oldOperandList = returnValue->operandList;
			for (i = 1; i < noOfOperand+1; i++)
			{
				term_free(oldOperandList[i]);
			}
			free(oldOperandList);
			secondTerm = aTerm->operandList[1];

			returnValue->operandList = (term **) malloc(sizeof(term *)*2);
			returnValue->operandList[0] = aSingleTerm;
			returnValue->operandList[1] = term_differentiateDivide(secondTerm, diffIndexNo);

			returnValue->noOfOperand = 2;

			returnValue->operationList = (int *) malloc(sizeof(int)*2);
			returnValue->operationList[0] = OP_MULT;
			returnValue->operationList[1] = OP_MULT;
		}
		else
		{
			//
			offsetConst = 1;
			offsetExponent = 0;
			for (i = 0; i < noOfOperand; i++)
			{
				aTerm1 = operandList[i];
				aLiteral1 = term_getLiteral(aTerm1);

				if (aLiteral1->isConstant == 1)
				{
					aSingleTermConst = returnValue->operandList[0];
					aSingleLiteralConst = term_getLiteral(aSingleTermConst);
					aSingleLiteralConst->isConstant = 1;
					aSingleLiteralConst->value = aLiteral1->value;

					offsetConst = 0;
				}
				else
				{
					aSingleTerm = returnValue->operandList[offsetConst+offsetExponent+i];
					

					// is same?
					if (aLiteral1->value == diffIndexNo)
					{
						//term_copy(aSingleTerm, aTerm1);

						if (aLiteral1->exponent == 1)
						{
							offsetExponent = -1;
						}
						else
						{
							term_copySingle(aSingleTerm, aTerm1);
							aSingleLiteral = term_getLiteral(aSingleTerm);

							// multiple exponent with constant
							aSingleTermConst = returnValue->operandList[0];
							aSingleLiteralConst = term_getLiteral(aSingleTermConst);
							aSingleLiteralConst->value *= aSingleLiteral->exponent;
							

							aSingleLiteral->exponent--;
						}


						//aSingleTerm = returnValue->operandList[0];
						//aSingleLiteral = term_getLiteral(aSingleTerm);
						//aSingleLiteral->value = aLiteral1->value;
					}
					else
					{
						term_copySingle(aSingleTerm, aTerm1);
					}
				}
			}

			finalTotalNoOfOperand = offsetConst+offsetExponent+noOfOperand;

			// free extra
			for (i = finalTotalNoOfOperand; i < noOfOperand+1; i++)
			{
				aSingleTerm = returnValue->operandList[i];
				term_free(aSingleTerm);
			}

			oldList = returnValue->operandList;

			if (finalTotalNoOfOperand == 1)
			{
				// special case for our problem
				returnValue->aLiteral = oldList[0]->aLiteral;

				free(oldList[0]);
			}
			else
			{
				returnValue->operandList = (term **) malloc(sizeof(term *)*finalTotalNoOfOperand);
				memcpy(returnValue->operandList, oldList, sizeof(term *)*finalTotalNoOfOperand);

				// opeartion
				returnValue->operationList = (int *) malloc(sizeof(int)*finalTotalNoOfOperand);
				for (i = 0; i < finalTotalNoOfOperand; i++)
				{
					returnValue->operationList[i] = OP_MULT;
				}

			}

			returnValue->noOfOperand = finalTotalNoOfOperand;

			free(oldList);



			//oldList = returnValue->operandList;
		}


	}
	else
	{
		oldOperandList = returnValue->operandList;

		memcpy(returnValue, oldOperandList[0], sizeof(term));
		free(oldOperandList[0]);

		for (i = 1; i < noOfOperand+1; i++)
		{
			term_free(oldOperandList[i]);
		}

		returnValue->aLiteral->value = 0;
		returnValue->noOfOperand = 1;

		free(oldOperandList);
	}

	return returnValue;
}


term *term_diffTermWithOneLiteral(term *aTermSingle, int diffIndexNo)
{
	term *returnValue;
	literal *aLiteralSingle;

	literal *tempLiteral;

	literal *tempLiteral1;
	literal *tempLiteral2;

	term *tempTerm;

	term *tempTerm1;
	term *tempTerm2;

	aLiteralSingle = aTermSingle->aLiteral;

	if (aLiteralSingle->isConstant == 1)
	{
		// set zero
		returnValue = NULL;
	}
	else
	{
		if (aLiteralSingle->value == diffIndexNo)
		{
			

			if (aLiteralSingle->exponent == 1)
			{
				tempLiteral = literal_new();

				tempLiteral->exponent = 1;
				tempLiteral->isConstant = 1;
				tempLiteral->value = 1;

				tempTerm = term_createTermFromLiteral(tempLiteral);
			}
			else
			{
				//
				tempLiteral1 = literal_new();

				tempLiteral1->isConstant = 1;
				tempLiteral1->value = (float) aLiteralSingle->exponent;

				tempTerm1 = term_createTermFromLiteral(tempLiteral1);

				//
				tempLiteral2 = literal_new();

				tempLiteral2->exponent = aLiteralSingle->exponent-1;
				tempLiteral2->isConstant = 0;
				tempLiteral2->value = (float) diffIndexNo;

				tempTerm2 = term_createTermFromLiteral(tempLiteral2);

				//
				tempTerm = term_new();
				tempTerm->noOfOperand = 2;
				tempTerm->operandList = (term **) malloc(sizeof(term *)*tempTerm->noOfOperand);
				tempTerm->operationList = (int *) malloc(sizeof(int)*tempTerm->noOfOperand);

				tempTerm->operandList[0] = tempTerm1;
				tempTerm->operandList[1] = tempTerm2;

				tempTerm->operationList[0] = OP_MULT;
				tempTerm->operationList[1] = OP_MULT;	// NO USE
			}

			

			returnValue = tempTerm;
		}
		else
		{
			// set zero
			returnValue = NULL;

		}
	}
	return returnValue;
}

term *term_differentiateAddMinus(term *aTerm, int diffIndexNo)
{
	term *returnValue;

	term *aTermSingle;

	term **oldOperandList;
	term **newOperandList;
	term **operandList;

	int noOfOperand;

	int i;

	int finalTotalNoOfOperand;
	int noOfZeroTerm;

	int index;

	term *aDiffTerm;

	int *oldOperationList;
	int *newOperationList;

	literal *aLiteralSingle;

	returnValue = term_new();

	noOfOperand = aTerm->noOfOperand;
	operandList = aTerm->operandList;
	oldOperationList = aTerm->operationList;

	noOfZeroTerm = 0;

	// malloc
	returnValue->operandList = (term **) malloc(sizeof(term *)*noOfOperand);
	for (i = 0; i < noOfOperand; i++)
	{
		aTermSingle = operandList[i];

if (i == 3)
{
	printf("");
}
		
		if (aTermSingle->noOfOperand == 1)
		{
			/// diff one
			aDiffTerm = term_diffTermWithOneLiteral(aTermSingle, diffIndexNo);

			if (aDiffTerm == NULL)
			{
				noOfZeroTerm++;
			}

			returnValue->operandList[i] = aDiffTerm;
		}
		else
		{
			returnValue->operandList[i] = term_differentiate(aTermSingle, diffIndexNo);

			// if a zero term, make it to NULL
			aTermSingle = returnValue->operandList[i];
			if (aTermSingle->noOfOperand == 1)
			{
				aLiteralSingle = aTermSingle->aLiteral;
				if ((aLiteralSingle->isConstant == 1) && (aLiteralSingle->value == 0))
				{
					term_free(aTermSingle);

					returnValue->operandList[i] = NULL;
					noOfZeroTerm++;
				}
			}
		}
	}

if (noOfOperand == 311)
{
	printf("");
}

	// remove zero term
	finalTotalNoOfOperand = noOfOperand - noOfZeroTerm;

	if (finalTotalNoOfOperand == 0)
	{
		oldOperandList = returnValue->operandList;
		
		free(oldOperandList);

		returnValue->noOfOperand = 1;

		returnValue->aLiteral = literal_createLiteralFromConstant(0);
	}
	else if (finalTotalNoOfOperand == 1)
	{
		oldOperandList = returnValue->operandList;

		for (i = 0; i < noOfOperand; i++)
		{
			if (oldOperandList[i] != NULL)
			//if (isZero[i] == 0)
			{
				memcpy(returnValue, oldOperandList[i], sizeof(term));
				//term_free(oldOperandList[i]);
				free(oldOperandList[i]);
				break;
			}
		}
		
		free(oldOperandList);

		//returnValue->noOfOperand = finalTotalNoOfOperand;
	}
	else
	{
		oldOperandList = returnValue->operandList;

		newOperandList = (term **) malloc(sizeof(term *)*finalTotalNoOfOperand);
		newOperationList = (int *) malloc(sizeof(int)*finalTotalNoOfOperand);
		index = 0;
		for (i = 0; i < noOfOperand; i++)
		{
			if (oldOperandList[i] != NULL)
			{
				newOperandList[index] = oldOperandList[i];
				newOperationList[index] = oldOperationList[i];
				index++;
			}
		}
		free(oldOperandList);

		returnValue->operandList = newOperandList;
		returnValue->operationList = newOperationList;

		returnValue->noOfOperand = finalTotalNoOfOperand;
	}

	

	return returnValue;
}


term *term_differentiateDivide(term *aTerm, int diffIndexNo)
{
	term *returnValue;

	term **operandList;

	term *divider;
	term *dividend;

	term *beforeTerm;
	term *afterTerm;

	term *beforeTerm1;
	term *beforeTerm2;

	term *afterTerm1;
	term *afterTerm2;

	literal *aLiteralSingle;

	int i;

	returnValue = term_new();

	operandList = aTerm->operandList;

	returnValue->noOfOperand = 2;
	returnValue->operandList = (term **) malloc(sizeof(term *)*returnValue->noOfOperand);
	returnValue->operationList = (int *) malloc(sizeof(int)*returnValue->noOfOperand);

	for (i = 0; i < returnValue->noOfOperand; i++)
	{
		returnValue->operandList[i] = term_new();
		returnValue->operationList[i] = OP_DIVIDE;
	}

	// divider
	term_free(returnValue->operandList[1]);
	//term_copy(divider, operandList[1]);
	divider = term_clone(operandList[1]);
	returnValue->operandList[1] = divider;
	if (divider->noOfOperand == 1)
	{
		aLiteralSingle = divider->aLiteral;
		if (aLiteralSingle->isConstant == 0)
		{
			aLiteralSingle->exponent *= 2;
		}
	}
	else
	{
		divider->exponent *= 2;
	}

	// dividend
	dividend = returnValue->operandList[0];

	dividend->noOfOperand = 2;
	dividend->operandList = (term **) malloc(sizeof(term *)*dividend->noOfOperand);
	dividend->operationList = (int *) malloc(sizeof(int)*dividend->noOfOperand);

	for (i = 0; i < dividend->noOfOperand; i++)
	{
		dividend->operandList[i] = term_new();
		dividend->operationList[i] = OP_MINUS;
	}

	// before
	beforeTerm = dividend->operandList[0];
	
	beforeTerm->noOfOperand = 2;
	beforeTerm->operandList = (term **) malloc(sizeof(term *)*beforeTerm->noOfOperand);
	beforeTerm->operationList = (int *) malloc(sizeof(int)*beforeTerm->noOfOperand);

	for (i = 0; i < beforeTerm->noOfOperand; i++)
	{
		//beforeTerm->operandList[i] = term_new();
		beforeTerm->operationList[i] = OP_MULT;
	}

	//beforeTerm1 = term_new();	

	//term_copy(beforeTerm1, operandList[1]);
	beforeTerm1 = term_clone(operandList[1]);
	beforeTerm2 = term_differentiate(operandList[0], diffIndexNo);

	beforeTerm->operandList[0] = beforeTerm1;
	beforeTerm->operandList[1] = beforeTerm2;

	// after
	afterTerm = dividend->operandList[1];

	afterTerm->noOfOperand = 2;
	afterTerm->operandList = (term **) malloc(sizeof(term *)*afterTerm->noOfOperand);
	afterTerm->operationList = (int *) malloc(sizeof(int)*afterTerm->noOfOperand);

	for (i = 0; i < afterTerm->noOfOperand; i++)
	{
		//beforeTerm->operandList[i] = term_new();
		afterTerm->operationList[i] = OP_MULT;
	}

	//afterTerm1 = term_new();	

	//term_copy(afterTerm1, operandList[0]);
	afterTerm1 = term_clone(operandList[0]);
	afterTerm2 = term_differentiate(operandList[1], diffIndexNo);

	afterTerm->operandList[0] = afterTerm1;
	afterTerm->operandList[1] = afterTerm2;
	
	return returnValue;
}


term *term_differentiate(term *aTerm, int diffIndexNo)
{
	term *returnValue;

	int operationNo;

	if (aTerm->noOfOperand == 1)
	{
		if (aTerm->aLiteral == NULL)
		{
			returnValue = term_differentiate(aTerm->operandList[0], diffIndexNo);
		}
		else
		{
			returnValue = term_diffTermWithOneLiteral(aTerm, diffIndexNo);
		}
	}
	else
	{
		operationNo = aTerm->operationList[0];

		switch (operationNo)
		{
		case OP_SUM:
		case OP_MINUS:
			returnValue = term_differentiateAddMinus(aTerm, diffIndexNo);
			break;
		case OP_MULT:
			returnValue = term_differentiateMultiplication(aTerm, diffIndexNo);
			break;
		case OP_DIVIDE:
			returnValue = term_differentiateDivide(aTerm, diffIndexNo);
			break;
		default:
			break;
		}
	}

	return returnValue;
}


// testing
void test_differentiateAddMinus()
{
	term *aTerm;

	term *diffTerm;

	literal *aLiteral1;
	literal *aLiteral2;
	literal *aLiteral3;

	term *aTerm1;
	term *aTerm2;
	term *aTerm3;

	int diffIndexNo;

	aTerm = term_new();

	aTerm->noOfOperand = 3;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	aLiteral1 = literal_createLiteralFromConstant(4);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);
	aLiteral2 = literal_createLiteralFromVariable(1, 7);
	aLiteral3 = literal_createLiteralFromVariable(2, 12);

	aTerm1 = term_createTermFromLiteral(aLiteral1);
	aTerm2 = term_createTermFromLiteral(aLiteral2);
	aTerm3 = term_createTermFromLiteral(aLiteral3);

	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;
	aTerm->operandList[2] = aTerm3;

	aTerm->operationList[0] = OP_SUM;
	aTerm->operationList[1] = OP_MINUS;
	aTerm->operationList[2] = OP_SUM;	// no use

	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}


void test_differentiateMultiplication()
{
	term *aTerm;

	term *diffTerm;

	literal *aLiteral1;
	literal *aLiteral2;
	literal *aLiteral3;

	term *aTerm1;
	term *aTerm2;
	term *aTerm3;

	int diffIndexNo;

	aTerm = term_new();

	aTerm->noOfOperand = 3;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	aLiteral1 = literal_createLiteralFromConstant(4);
	aLiteral2 = literal_createLiteralFromVariable(3, 9);
	aLiteral3 = literal_createLiteralFromVariable(0, 12);

	aTerm1 = term_createTermFromLiteral(aLiteral1);
	aTerm2 = term_createTermFromLiteral(aLiteral2);
	aTerm3 = term_createTermFromLiteral(aLiteral3);

	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;
	aTerm->operandList[2] = aTerm3;

	aTerm->operationList[0] = OP_MULT;
	aTerm->operationList[1] = OP_MULT;
	aTerm->operationList[2] = OP_MULT;	// no use

	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}


void test_differentiateAddMinusAndMult()
{
	term *aTerm;

	term *diffTerm;

	literal *aLiteral1;

	literal *aLiteral21;
	literal *aLiteral22;
	literal *aLiteral23;

	literal *aLiteral31;
	literal *aLiteral32;
	literal *aLiteral33;




	term *aTerm1;
	term *aTerm2;
	term *aTerm3;

	int diffIndexNo;

	aTerm = term_new();

	aTerm->noOfOperand = 3;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	aLiteral1 = literal_createLiteralFromConstant(4);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	//aLiteral21 = literal_createLiteralFromConstant(5);
	aLiteral21 = literal_createLiteralFromVariable(0, 5);
	aLiteral22 = literal_createLiteralFromVariable(1, 7);
	aLiteral23 = literal_createLiteralFromVariable(2, 12);

	aLiteral31 = literal_createLiteralFromConstant(8);
	aLiteral32 = literal_createLiteralFromVariable(3, 9);
	aLiteral33 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm1 = term_createTermFromLiteral(aLiteral1);

	// term 2
	aTerm2 = term_new();
	aTerm2->noOfOperand = 3;
	aTerm2->operandList = (term **) malloc(sizeof(term *)*aTerm2->noOfOperand);
	aTerm2->operationList = (int *) malloc(sizeof(int)*aTerm2->noOfOperand);
	aTerm2->operandList[0] = term_createTermFromLiteral(aLiteral21);
	aTerm2->operandList[1] = term_createTermFromLiteral(aLiteral22);
	aTerm2->operandList[2] = term_createTermFromLiteral(aLiteral23);
	aTerm2->operationList[0] = OP_MULT;
	aTerm2->operationList[1] = OP_MULT;
	aTerm2->operationList[2] = OP_MULT;

	// term 3
	aTerm3 = term_new();
	aTerm3->noOfOperand = 3;
	aTerm3->operandList = (term **) malloc(sizeof(term *)*aTerm3->noOfOperand);
	aTerm3->operationList = (int *) malloc(sizeof(int)*aTerm3->noOfOperand);
	aTerm3->operandList[0] = term_createTermFromLiteral(aLiteral31);
	aTerm3->operandList[1] = term_createTermFromLiteral(aLiteral32);
	aTerm3->operandList[2] = term_createTermFromLiteral(aLiteral33);
	aTerm3->operationList[0] = OP_MULT;
	aTerm3->operationList[1] = OP_MULT;
	aTerm3->operationList[2] = OP_MULT;

	//
	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;
	aTerm->operandList[2] = aTerm3;

	aTerm->operationList[0] = OP_SUM;
	aTerm->operationList[1] = OP_MINUS;
	aTerm->operationList[2] = OP_SUM;	// no use

	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}

void test_differentiateDivide()
{
	term *aTerm;

	term *diffTerm;

	literal *aLiteral1;
	literal *aLiteral2;


	term *aTerm1;
	term *aTerm2;


	int diffIndexNo;

	aTerm = term_new();

	aTerm->noOfOperand = 2;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	//aLiteral1 = literal_createLiteralFromConstant(4);
	aLiteral1 = literal_createLiteralFromVariable(0, 5);
	aLiteral2 = literal_createLiteralFromVariable(0, 7);


	aTerm1 = term_createTermFromLiteral(aLiteral1);
	aTerm2 = term_createTermFromLiteral(aLiteral2);


	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;


	aTerm->operationList[0] = OP_DIVIDE;
	aTerm->operationList[1] = OP_DIVIDE;


	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}



void test_differentiateAddMinusAndMultAndDivide()
{
	term *aTerm;

	term *aTerm1;
	term *aTerm2;

	term *diffTerm;

	literal *aLiteral11;

	literal *aLiteral121;
	literal *aLiteral122;
	literal *aLiteral123;



	literal *aLiteral21;

	literal *aLiteral221;
	literal *aLiteral222;
	literal *aLiteral223;

	literal *aLiteral231;
	literal *aLiteral232;
	literal *aLiteral233;

	term *aTerm11;
	term *aTerm12;
	//term *aTerm13;

	term *aTerm21;
	term *aTerm22;
	term *aTerm23;

	int diffIndexNo;

	// term
	aTerm = term_new();

	aTerm->noOfOperand = 2;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	//**** term 1
	aTerm1 = term_new();

	aTerm1->noOfOperand = 2;
	aTerm1->operandList = (term **) malloc(sizeof(term *)*aTerm1->noOfOperand);
	aTerm1->operationList = (int *) malloc(sizeof(int)*aTerm1->noOfOperand);

	aLiteral11 = literal_createLiteralFromConstant(4);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	aLiteral121 = literal_createLiteralFromConstant(5);
	//aLiteral121 = literal_createLiteralFromVariable(0, 8);
	aLiteral122 = literal_createLiteralFromVariable(0, 6);
	aLiteral123 = literal_createLiteralFromVariable(4, 12);

	//aLiteral131 = literal_createLiteralFromConstant(8);
	//aLiteral132 = literal_createLiteralFromVariable(3, 9);
	//aLiteral133 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm11 = term_createTermFromLiteral(aLiteral11);

	// term 2
	aTerm12 = term_new();
	aTerm12->noOfOperand = 2;
	aTerm12->operandList = (term **) malloc(sizeof(term *)*aTerm12->noOfOperand);
	aTerm12->operationList = (int *) malloc(sizeof(int)*aTerm12->noOfOperand);
	aTerm12->operandList[0] = term_createTermFromLiteral(aLiteral121);
	aTerm12->operandList[1] = term_createTermFromLiteral(aLiteral122);
	//aTerm12->operandList[2] = term_createTermFromLiteral(aLiteral123);
	aTerm12->operationList[0] = OP_MULT;
	aTerm12->operationList[1] = OP_MULT;
	//aTerm12->operationList[2] = OP_MULT;

	// term 3
	/*aTerm13 = term_new();
	aTerm13->noOfOperand = 3;
	aTerm13->operandList = (term **) malloc(sizeof(term *)*aTerm13->noOfOperand);
	aTerm13->operationList = (int *) malloc(sizeof(int)*aTerm13->noOfOperand);
	aTerm13->operandList[0] = term_createTermFromLiteral(aLiteral131);
	aTerm13->operandList[1] = term_createTermFromLiteral(aLiteral132);
	aTerm13->operandList[2] = term_createTermFromLiteral(aLiteral133);
	aTerm13->operationList[0] = OP_MULT;
	aTerm13->operationList[1] = OP_MULT;
	aTerm13->operationList[2] = OP_MULT;
	*/

	//
	aTerm1->operandList[0] = aTerm11;
	aTerm1->operandList[1] = aTerm12;
	//aTerm1->operandList[2] = aTerm13;

	aTerm1->operationList[0] = OP_SUM;
	aTerm1->operationList[1] = OP_MINUS;
	//aTerm1->operationList[2] = OP_SUM;	// no use

	//**** term 2
	aTerm2 = term_new();

	aTerm2->noOfOperand = 3;
	aTerm2->operandList = (term **) malloc(sizeof(term *)*aTerm2->noOfOperand);
	aTerm2->operationList = (int *) malloc(sizeof(int)*aTerm2->noOfOperand);

	aLiteral21 = literal_createLiteralFromConstant(9);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	//aLiteral21 = literal_createLiteralFromConstant(5);
	aLiteral221 = literal_createLiteralFromVariable(0, 5);
	aLiteral222 = literal_createLiteralFromVariable(1, 7);
	aLiteral223 = literal_createLiteralFromVariable(2, 12);

	aLiteral231 = literal_createLiteralFromConstant(8);
	aLiteral232 = literal_createLiteralFromVariable(3, 9);
	aLiteral233 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm21 = term_createTermFromLiteral(aLiteral21);

	// term 2
	aTerm22 = term_new();
	aTerm22->noOfOperand = 3;
	aTerm22->operandList = (term **) malloc(sizeof(term *)*aTerm22->noOfOperand);
	aTerm22->operationList = (int *) malloc(sizeof(int)*aTerm22->noOfOperand);
	aTerm22->operandList[0] = term_createTermFromLiteral(aLiteral221);
	aTerm22->operandList[1] = term_createTermFromLiteral(aLiteral222);
	aTerm22->operandList[2] = term_createTermFromLiteral(aLiteral223);
	aTerm22->operationList[0] = OP_MULT;
	aTerm22->operationList[1] = OP_MULT;
	aTerm22->operationList[2] = OP_MULT;

	// term 3
	aTerm23 = term_new();
	aTerm23->noOfOperand = 3;
	aTerm23->operandList = (term **) malloc(sizeof(term *)*aTerm23->noOfOperand);
	aTerm23->operationList = (int *) malloc(sizeof(int)*aTerm23->noOfOperand);
	aTerm23->operandList[0] = term_createTermFromLiteral(aLiteral231);
	aTerm23->operandList[1] = term_createTermFromLiteral(aLiteral232);
	aTerm23->operandList[2] = term_createTermFromLiteral(aLiteral233);
	aTerm23->operationList[0] = OP_MULT;
	aTerm23->operationList[1] = OP_MULT;
	aTerm23->operationList[2] = OP_MULT;

	//
	aTerm2->operandList[0] = aTerm21;
	aTerm2->operandList[1] = aTerm22;
	aTerm2->operandList[2] = aTerm23;

	aTerm2->operationList[0] = OP_SUM;
	aTerm2->operationList[1] = OP_MINUS;
	aTerm2->operationList[2] = OP_SUM;	// no use

	// combine term1 and term2
	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;

	aTerm->operationList[0] = OP_DIVIDE;
	aTerm->operationList[1] = OP_DIVIDE;  // no use

	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}



void test_differentiateAddMinusAndMultAndDivide2()
{

	term *aTerm;
	term *diffTerm;

	term *aTerm1;

	term *aTerm11;
	term *aTerm12;

	literal *aLiteral111;

	literal *aLiteral1121;
	literal *aLiteral1122;
	literal *aLiteral1123;

	literal *aLiteral121;

	literal *aLiteral1221;
	literal *aLiteral1222;
	literal *aLiteral1223;

	literal *aLiteral1231;
	literal *aLiteral1232;
	literal *aLiteral1233;

	term *aTerm111;
	term *aTerm112;
	//term *aTerm113;

	term *aTerm121;
	term *aTerm122;
	term *aTerm123;


	term *aTerm2;

	term *aTerm21;
	term *aTerm22;

	literal *aLiteral211;

	literal *aLiteral2121;
	literal *aLiteral2122;
	literal *aLiteral2123;

	literal *aLiteral221;

	literal *aLiteral2221;
	literal *aLiteral2222;
	literal *aLiteral2223;

	literal *aLiteral2231;
	literal *aLiteral2232;
	literal *aLiteral2233;

	term *aTerm211;
	term *aTerm212;
	//term *aTerm113;

	term *aTerm221;
	term *aTerm222;
	term *aTerm223;

	int diffIndexNo;

	//
	aTerm = term_new();

	aTerm->noOfOperand = 2;
	aTerm->operandList = (term **) malloc(sizeof(term *)*aTerm->noOfOperand);
	aTerm->operationList = (int *) malloc(sizeof(int)*aTerm->noOfOperand);

	// first term
	aTerm1 = term_new();

	aTerm1->noOfOperand = 2;
	aTerm1->operandList = (term **) malloc(sizeof(term *)*aTerm1->noOfOperand);
	aTerm1->operationList = (int *) malloc(sizeof(int)*aTerm1->noOfOperand);

	//**** term 1
	aTerm11 = term_new();

	aTerm11->noOfOperand = 2;
	aTerm11->operandList = (term **) malloc(sizeof(term *)*aTerm11->noOfOperand);
	aTerm11->operationList = (int *) malloc(sizeof(int)*aTerm11->noOfOperand);

	aLiteral111 = literal_createLiteralFromConstant(4);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	aLiteral1121 = literal_createLiteralFromConstant(5);
	//aLiteral121 = literal_createLiteralFromVariable(0, 8);
	aLiteral1122 = literal_createLiteralFromVariable(0, 6);
	aLiteral1123 = literal_createLiteralFromVariable(4, 12);

	//aLiteral131 = literal_createLiteralFromConstant(8);
	//aLiteral132 = literal_createLiteralFromVariable(3, 9);
	//aLiteral133 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm111 = term_createTermFromLiteral(aLiteral111);

	// term 2
	aTerm112 = term_new();
	aTerm112->noOfOperand = 2;
	aTerm112->operandList = (term **) malloc(sizeof(term *)*aTerm112->noOfOperand);
	aTerm112->operationList = (int *) malloc(sizeof(int)*aTerm112->noOfOperand);
	aTerm112->operandList[0] = term_createTermFromLiteral(aLiteral1121);
	aTerm112->operandList[1] = term_createTermFromLiteral(aLiteral1122);
	//aTerm12->operandList[2] = term_createTermFromLiteral(aLiteral123);
	aTerm112->operationList[0] = OP_MULT;
	aTerm112->operationList[1] = OP_MULT;
	//aTerm12->operationList[2] = OP_MULT;

	// term 3
	/*aTerm13 = term_new();
	aTerm13->noOfOperand = 3;
	aTerm13->operandList = (term **) malloc(sizeof(term *)*aTerm13->noOfOperand);
	aTerm13->operationList = (int *) malloc(sizeof(int)*aTerm13->noOfOperand);
	aTerm13->operandList[0] = term_createTermFromLiteral(aLiteral131);
	aTerm13->operandList[1] = term_createTermFromLiteral(aLiteral132);
	aTerm13->operandList[2] = term_createTermFromLiteral(aLiteral133);
	aTerm13->operationList[0] = OP_MULT;
	aTerm13->operationList[1] = OP_MULT;
	aTerm13->operationList[2] = OP_MULT;
	*/

	//
	aTerm11->operandList[0] = aTerm111;
	aTerm11->operandList[1] = aTerm112;
	//aTerm11->operandList[2] = aTerm113;

	aTerm11->operationList[0] = OP_SUM;
	aTerm11->operationList[1] = OP_MINUS;
	aTerm11->operationList[2] = OP_SUM;	// no use

	//**** term 2
	aTerm12 = term_new();

	aTerm12->noOfOperand = 3;
	aTerm12->operandList = (term **) malloc(sizeof(term *)*aTerm12->noOfOperand);
	aTerm12->operationList = (int *) malloc(sizeof(int)*aTerm12->noOfOperand);

	aLiteral121 = literal_createLiteralFromConstant(9);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	//aLiteral21 = literal_createLiteralFromConstant(5);
	aLiteral1221 = literal_createLiteralFromVariable(0, 5);
	aLiteral1222 = literal_createLiteralFromVariable(1, 7);
	aLiteral1223 = literal_createLiteralFromVariable(2, 12);

	aLiteral1231 = literal_createLiteralFromConstant(8);
	aLiteral1232 = literal_createLiteralFromVariable(3, 9);
	aLiteral1233 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm121 = term_createTermFromLiteral(aLiteral121);

	// term 2
	aTerm122 = term_new();
	aTerm122->noOfOperand = 3;
	aTerm122->operandList = (term **) malloc(sizeof(term *)*aTerm122->noOfOperand);
	aTerm122->operationList = (int *) malloc(sizeof(int)*aTerm122->noOfOperand);
	aTerm122->operandList[0] = term_createTermFromLiteral(aLiteral1221);
	aTerm122->operandList[1] = term_createTermFromLiteral(aLiteral1222);
	aTerm122->operandList[2] = term_createTermFromLiteral(aLiteral1223);
	aTerm122->operationList[0] = OP_MULT;
	aTerm122->operationList[1] = OP_MULT;
	aTerm122->operationList[2] = OP_MULT;

	// term 3
	aTerm123 = term_new();
	aTerm123->noOfOperand = 3;
	aTerm123->operandList = (term **) malloc(sizeof(term *)*aTerm123->noOfOperand);
	aTerm123->operationList = (int *) malloc(sizeof(int)*aTerm123->noOfOperand);
	aTerm123->operandList[0] = term_createTermFromLiteral(aLiteral1231);
	aTerm123->operandList[1] = term_createTermFromLiteral(aLiteral1232);
	aTerm123->operandList[2] = term_createTermFromLiteral(aLiteral1233);
	aTerm123->operationList[0] = OP_MULT;
	aTerm123->operationList[1] = OP_MULT;
	aTerm123->operationList[2] = OP_MULT;

	//
	aTerm12->operandList[0] = aTerm121;
	aTerm12->operandList[1] = aTerm122;
	aTerm12->operandList[2] = aTerm123;

	aTerm12->operationList[0] = OP_SUM;
	aTerm12->operationList[1] = OP_MINUS;
	aTerm12->operationList[2] = OP_SUM;	// no use

	// combine term1 and term2
	aTerm1->operandList[0] = aTerm11;
	aTerm1->operandList[1] = aTerm12;

	aTerm1->operationList[0] = OP_DIVIDE;
	aTerm1->operationList[1] = OP_DIVIDE;  // no use



	// second term
	aTerm2 = term_new();

	aTerm2->noOfOperand = 2;
	aTerm2->operandList = (term **) malloc(sizeof(term *)*aTerm2->noOfOperand);
	aTerm2->operationList = (int *) malloc(sizeof(int)*aTerm2->noOfOperand);

	//**** term 1
	aTerm21 = term_new();

	aTerm21->noOfOperand = 2;
	aTerm21->operandList = (term **) malloc(sizeof(term *)*aTerm21->noOfOperand);
	aTerm21->operationList = (int *) malloc(sizeof(int)*aTerm21->noOfOperand);

	aLiteral211 = literal_createLiteralFromConstant(4);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	aLiteral2121 = literal_createLiteralFromConstant(5);
	//aLiteral121 = literal_createLiteralFromVariable(0, 8);
	aLiteral2122 = literal_createLiteralFromVariable(0, 6);
	aLiteral2123 = literal_createLiteralFromVariable(4, 12);

	//aLiteral131 = literal_createLiteralFromConstant(8);
	//aLiteral132 = literal_createLiteralFromVariable(3, 9);
	//aLiteral133 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm211 = term_createTermFromLiteral(aLiteral211);

	// term 2
	aTerm212 = term_new();
	aTerm212->noOfOperand = 2;
	aTerm212->operandList = (term **) malloc(sizeof(term *)*aTerm212->noOfOperand);
	aTerm212->operationList = (int *) malloc(sizeof(int)*aTerm212->noOfOperand);
	aTerm212->operandList[0] = term_createTermFromLiteral(aLiteral2121);
	aTerm212->operandList[1] = term_createTermFromLiteral(aLiteral2122);
	//aTerm12->operandList[2] = term_createTermFromLiteral(aLiteral123);
	aTerm212->operationList[0] = OP_MULT;
	aTerm212->operationList[1] = OP_MULT;
	//aTerm12->operationList[2] = OP_MULT;

	// term 3
	/*aTerm13 = term_new();
	aTerm13->noOfOperand = 3;
	aTerm13->operandList = (term **) malloc(sizeof(term *)*aTerm13->noOfOperand);
	aTerm13->operationList = (int *) malloc(sizeof(int)*aTerm13->noOfOperand);
	aTerm13->operandList[0] = term_createTermFromLiteral(aLiteral131);
	aTerm13->operandList[1] = term_createTermFromLiteral(aLiteral132);
	aTerm13->operandList[2] = term_createTermFromLiteral(aLiteral133);
	aTerm13->operationList[0] = OP_MULT;
	aTerm13->operationList[1] = OP_MULT;
	aTerm13->operationList[2] = OP_MULT;
	*/

	//
	aTerm21->operandList[0] = aTerm211;
	aTerm21->operandList[1] = aTerm212;
	//aTerm11->operandList[2] = aTerm113;

	aTerm21->operationList[0] = OP_SUM;
	aTerm21->operationList[1] = OP_MINUS;
	aTerm21->operationList[2] = OP_SUM;	// no use

	//**** term 2
	aTerm22 = term_new();

	aTerm22->noOfOperand = 3;
	aTerm22->operandList = (term **) malloc(sizeof(term *)*aTerm22->noOfOperand);
	aTerm22->operationList = (int *) malloc(sizeof(int)*aTerm22->noOfOperand);

	aLiteral221 = literal_createLiteralFromConstant(9);
	//aLiteral1 = literal_createLiteralFromVariable(0, 5);

	//aLiteral21 = literal_createLiteralFromConstant(5);
	aLiteral2221 = literal_createLiteralFromVariable(0, 5);
	aLiteral2222 = literal_createLiteralFromVariable(1, 7);
	aLiteral2223 = literal_createLiteralFromVariable(2, 12);

	aLiteral2231 = literal_createLiteralFromConstant(8);
	aLiteral2232 = literal_createLiteralFromVariable(3, 9);
	aLiteral2233 = literal_createLiteralFromVariable(0, 15);

	// term 1
	aTerm221 = term_createTermFromLiteral(aLiteral121);

	// term 2
	aTerm222 = term_new();
	aTerm222->noOfOperand = 3;
	aTerm222->operandList = (term **) malloc(sizeof(term *)*aTerm222->noOfOperand);
	aTerm222->operationList = (int *) malloc(sizeof(int)*aTerm222->noOfOperand);
	aTerm222->operandList[0] = term_createTermFromLiteral(aLiteral2221);
	aTerm222->operandList[1] = term_createTermFromLiteral(aLiteral2222);
	aTerm222->operandList[2] = term_createTermFromLiteral(aLiteral2223);
	aTerm222->operationList[0] = OP_MULT;
	aTerm222->operationList[1] = OP_MULT;
	aTerm222->operationList[2] = OP_MULT;

	// term 3
	aTerm223 = term_new();
	aTerm223->noOfOperand = 3;
	aTerm223->operandList = (term **) malloc(sizeof(term *)*aTerm223->noOfOperand);
	aTerm223->operationList = (int *) malloc(sizeof(int)*aTerm223->noOfOperand);
	aTerm223->operandList[0] = term_createTermFromLiteral(aLiteral2231);
	aTerm223->operandList[1] = term_createTermFromLiteral(aLiteral2232);
	aTerm223->operandList[2] = term_createTermFromLiteral(aLiteral2233);
	aTerm223->operationList[0] = OP_MULT;
	aTerm223->operationList[1] = OP_MULT;
	aTerm223->operationList[2] = OP_MULT;

	//
	aTerm22->operandList[0] = aTerm221;
	aTerm22->operandList[1] = aTerm222;
	aTerm22->operandList[2] = aTerm223;

	aTerm22->operationList[0] = OP_SUM;
	aTerm22->operationList[1] = OP_MINUS;
	aTerm22->operationList[2] = OP_SUM;	// no use

	// combine term1 and term2
	aTerm2->operandList[0] = aTerm21;
	aTerm2->operandList[1] = aTerm22;

	aTerm2->operationList[0] = OP_DIVIDE;
	aTerm2->operationList[1] = OP_DIVIDE;  // no use

	// override
	//aTerm1->noOfOperand = 1;
	//aTerm1->aLiteral = literal_createLiteralFromConstant(3);

	//aTerm2->noOfOperand = 1;
	//aTerm2->aLiteral = literal_createLiteralFromConstant(4);


	// final combine the first term and the second term
	aTerm->operandList[0] = aTerm1;
	aTerm->operandList[1] = aTerm2;

	aTerm->operationList[0] = OP_SUM;
	aTerm->operationList[1] = OP_SUM;  // no use


	diffIndexNo = 0;

	printf("Org. equation....\n");
	term_print(aTerm);
	printf("\n");

	printf("Differentiating...\n");
	diffTerm = term_differentiate(aTerm, diffIndexNo);

	printf("Differentiated equation....\n");
	term_print(diffTerm);
	printf("\n");
}


int main4()
{
	//test_differentiateAddMinus();

	//test_differentiateMultiplication();

	//test_differentiateAddMinusAndMult();

	//test_differentiateDivide();

	//test_differentiateAddMinusAndMultAndDivide();

	test_differentiateAddMinusAndMultAndDivide2();

	return 0;

}
