/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void leastsqrs_mR(
PmR mA,
PmR mb,
PmR mx
)
{
int A_r =mA->rows;
int A_c =mA->cols;

//MAT_TYPE pbAx    [MXR][MXC];
//mR mAx     ={MXR,MXC,&pbAx    [0][0]};
//MAT_TYPE pTrpsA  [MXR][MXC];
//mR mTrpsA  ={MXR,MXC,&pTrpsA  [0][0]};
//MAT_TYPE pTrpsA_A[MXR][MXC];
//mR mTrpsA_A={MXR,MXC,&pTrpsA_A[0][0]};
//MAT_TYPE pTrpsA_b[MXR][MXC];
//mR mTrpsA_b={MXR,MXC,&pTrpsA_b[0][0]};

mR mAx;
mR mTrpsA;
mR mTrpsA_A;
mR mTrpsA_b;

//MAT_TYPE pAssNorSys[MXR][MXC];
//mR mAssNorSys ={MXR,MXC,&pAssNorSys [0][0]};

mR mAssNorSys;

                    mAx.rows=A_r;         mAx.cols=  1;
                 mTrpsA.rows=A_c;      mTrpsA.cols=A_r;
               mTrpsA_A.rows=A_c;    mTrpsA_A.cols=A_c;
               mTrpsA_b.rows=A_c;    mTrpsA_b.cols=  1;
             mAssNorSys.rows=A_c;  mAssNorSys.cols=A_r;

			 mAx.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAx.rows*mAx.cols);
			 mTrpsA.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA.rows*mTrpsA.cols);
			 mTrpsA_A.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA_A.rows*mTrpsA_A.cols);
			 mTrpsA_b.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA_b.rows*mTrpsA_b.cols);
			 mAssNorSys.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAssNorSys.rows*mAssNorSys.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  transpose_mR( mA,&mTrpsA);
       mul_mR(&mTrpsA,mA,&mTrpsA_A);
       mul_mR(&mTrpsA,mb,&mTrpsA_b);
       copy_mR(&mTrpsA_A,&mAssNorSys);
     copy_c_R(&mTrpsA_b,0,&mAssNorSys,A_c);
 gaussjordan_mR(&mAssNorSys);
     copy_c_R(&mAssNorSys,A_c,mx,0);

	 free(mAx.pb);
	 free(mTrpsA.pb);
	 free(mTrpsA_A.pb);
	 free(mTrpsA_b.pb);
	 free(mAssNorSys.pb);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void orthprojwb_mR(
PmR mA,
PmR mb,
PmR mprojwb
)
{
int  A_c = mA->cols;

//MAT_TYPE pbx[MXR][MXC];
//mR mx = {MXR,MXC,&pbx[0][0]};
mR mx;

            mx.rows=A_c;          mx.cols= 1;
			mx.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mx.rows*mx.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
       leastsqrs_mR(mA, mb,&mx);
          mul_mR(mA,&mx, mprojwb);

		  free(mx.pb);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void leastsqrs_meq_mR(
PmR mP,
PmR M,
PmR y)
{
   int i;
   int j;
   int p;

  for   (i=0;     i<mP->rows; i++)
    for (j=0,p=0; j< M->cols; j++)
          *(M->pb+i *M->cols+j) =  (MAT_TYPE) pow(*(mP->pb+i *mP->cols),p++);

   copy_c_R(mP,1,y,0);
}

