/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : On a MAT_TYPE.                                                        */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE gfpivotR(
PmR  m,
int      rowpivot,
int      colpivot,
int      colp,
int      rown_mns
)
{
MAT_TYPE f;
MAT_TYPE fn;
MAT_TYPE fn_mns;
MAT_TYPE fp;
MAT_TYPE fpivot;

   fpivot =  (*(m->pb+rowpivot *m->cols+colpivot));
       fp =  (*(m->pb+rowpivot *m->cols+colp    ));
   fn_mns = -(*(m->pb+rown_mns *m->cols+colpivot));
       fn =  (*(m->pb+rown_mns *m->cols+colp    ));

  if(fn_mns)
      f = (fpivot*fn) + (fp*fn_mns);
  else
      f =  *(m->pb+rown_mns *m->cols+colp);

 return(f);
}




/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void grpivotR(
PmR  m,
int  rowpivot,
int  colpivot,
int  rown_mns
)
{
   int colp;
MAT_TYPE f;

    if((*(m->pb+rowpivot *m->cols+colpivot)))
     {
      for(colp=(m->cols)-1 ; colp>-1 ; colp--)
        {
         f = gfpivotR(m, rowpivot, colpivot, colp, rown_mns);
         (*(m->pb+rown_mns  *m->cols+colp)) = f;
        }
      }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gcpivotnt0R(
PmR m,
int row,
int col)
{
MAT_TYPE   pivot;
MAT_TYPE pivot_n;
int      row_n;

         row_n=row+1;
         pivot= (MAT_TYPE) fabs(*(m->pb+row *m->cols+col));

   while(row_n<m->rows)
   {
    pivot_n= (MAT_TYPE) fabs(*(m->pb+row_n *m->cols+col));
       if(pivot_n>pivot || !pivot)
         {
          swap_r_R(m,row,row_n);
          pivot=pivot_n;
         }
    row_n++;
   }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a column.                                                      */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gcpivotR(
PmR  m,
int  rowpivot,
int  colpivot
)
{
int  rown_mns;

     gcpivotnt0R(m,rowpivot,colpivot);
     for(rown_mns=rowpivot+1; rown_mns<(m->rows); rown_mns++)
        {
          while( !(*(m->pb+rowpivot *m->cols+colpivot)) &&
                  (colpivot<m->cols)) colpivot++;
         grpivotR(m, rowpivot, colpivot,rown_mns);
        }
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  .                                                                 */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gdpivotR(
PmR  m
)
{
int      rowpivot;

     for(rowpivot = 0; rowpivot < (m->rows)-1  ;rowpivot++)
         gcpivotR(m, rowpivot,rowpivot);

}




