/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void LU_mR(
PmR m,
PmR mL,
PmR mU
)
{
MAT_TYPE pivot;
MAT_TYPE underpivot;
int    rowpivot;
int    rowunder;
int     col;

    zeros_mR(  mL);
   copy_mR(m,mU);

         col = 0;
for(rowpivot = 0; rowpivot<(mU->rows); rowpivot++)
{
  if(!(*(mU->pb+rowpivot *mU->cols+col)))
    {
     printf("\n Pivot error - A pivot is Zero");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  pivot =  (MAT_TYPE) 1./(*(mU->pb+rowpivot *mU->cols+col));

  *(mL->pb+rowpivot *mL->cols+col)=*(mU->pb+rowpivot *mU->cols+col);

  mul_r_R(mU,rowpivot,pivot);

  for(rowunder = rowpivot+1; rowunder<mU->rows; rowunder++)
     {

*(mL->pb+rowunder *mL->cols+col  )= (*(mU->pb+rowunder *mU->cols+col ));

                     underpivot =-(*(mU->pb+rowunder *mU->cols+col));

        add_r_R(mU,underpivot,rowpivot,rowunder);
     }
  col++;
}
}



/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void PLU_mR(
PmR m,
PmR mP,
PmR mL,
PmR mU
)
{
  MAT_TYPE pivot;
  MAT_TYPE underpivot;
  MAT_TYPE PIVOT_ZERO;
  MAT_TYPE PIVOT_UNDER;
     int ROW_T;
     int rowpivot;
     int rowunder;
     int col;

//MAT_TYPE pT [MXR][MXC];
//mR mT ={MXR,MXC,&pT [0][0]};
	 mR mT;

             mT.rows = mU->rows;       mT.cols = mU->cols;

			 mT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT.rows*mT.cols);

   eye_mR(   mP);
  zeros_mR(  mL);
   copy_mR(m,mU);

         col = 0;
for(rowpivot = 0; rowpivot<(mU->rows); rowpivot++)
{
      PIVOT_ZERO=(*(mU->pb+rowpivot *mU->cols+col));
  if(!PIVOT_ZERO)
    {
     ROW_T=rowpivot+1;
     while((ROW_T<(mU->rows)))
          {
           PIVOT_UNDER = (*(mU->pb+ROW_T *mU->cols+col));
           if(PIVOT_UNDER)
              {
               swap_r_R(mU,rowpivot,ROW_T);
               swap_r_R(mP,rowpivot,ROW_T);
               PIVOT_ZERO=1;
               ROW_T= (mU->rows)+10;
              }
           ROW_T++;
          }

     if(!PIVOT_ZERO)
       {
        printf("\n Pivot error - A pivot is Zero");
        printf("\n Press return to continue");
        //getchar();
        //exit(1);
       }
    }

  pivot =  (MAT_TYPE) 1./(*(mU->pb+rowpivot *mU->cols+col));

  *(mL->pb+rowpivot *mL->cols+col)=*(mU->pb+rowpivot *mU->cols+col);

  mul_r_R(mU,rowpivot,pivot);

  for(rowunder = rowpivot+1; rowunder<mU->rows; rowunder++)
     {

*(mL->pb+rowunder *mL->cols+col  )= (*(mU->pb+rowunder *mU->cols+col ));

                     underpivot =-(*(mU->pb+rowunder *mU->cols+col));

        add_r_R(mU,underpivot,rowpivot,rowunder);
     }
  col++;

  
}

     mul_mR( mP,m, &mT);
      LU_mR(&mT,mL, mU);

	  free(mT.pb);
}

