/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------ FUNCTION ---------------------------------- */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_symetric_mR(
PmR m,
int n)
{
int i;
int j;
MAT_TYPE Tnumer;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_symetric_mR() ");
     printf("\n error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        Tnumer =  (MAT_TYPE) rnd_I (n);

        *(m->pb+i *m->cols+j)   = Tnumer;
        *(m->pb+j *m->cols+i)   = Tnumer;
        }

}

/* ------------------------------ FUNCTION ---------------------------------- */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_symmetric_positive_definite_mR(
PmR m,
int n)
{
int i;
int j;
MAT_TYPE Tnumer;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_symmetric_positive_definite_mR()");
     printf("\n error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        Tnumer =  (MAT_TYPE) rndp_I (n);

         if(i==j)  Tnumer*=8;

        *(m->pb+i *m->cols+j)   = Tnumer;
        *(m->pb+j *m->cols+i)   = Tnumer;
        }

}

