/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copy_mR(
PmR mA,
PmR mB)
{
  int i,j;

  for (   i=0; i<mA->rows; i++)
    for ( j=0; j<mA->cols; j++)
      *(mB->pb+i *mB->cols+j) = *(mA->pb+i *mA->cols+j);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copydiag_mR(
PmR mA,
PmR mB)
{
int i,j;

eye_mR(mB);

for (i = 0 ; i < mA->rows ; i++)
  for ( j = 0; j < mA->cols ; j++)
      if(i==j) *(mB->pb+i *mB->cols+j  ) = *(mA->pb+i *mA->cols+j);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copy_Utrig_mR(
PmR mA,
PmR mB)
{
int i;
int j;

  for  ( i=0; i<mA->rows; i++)
    for( j=0; j<mA->cols; j++)
        if  (i<=j)(*(mB->pb+i *mB->cols+j)) = (*(mA->pb+i *mA->cols+j));
        else      (*(mB->pb+i *mB->cols+j)) =                         0;
}
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copy_Ltrig_mR(
PmR mA,
PmR mB)
{
int i;
int j;

  for  ( i=0; i<mA->rows; i++)
    for( j=0; j<mA->cols; j++)
        if  (i>=j)(*(mB->pb+i *mB->cols+j)) = (*(mA->pb+i *mA->cols+j));
        else      (*(mB->pb+i *mB->cols+j)) =                         0;
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copy_ArcB_mR(
PmR mA,
int r,
int c,
PmR mB)
{
int i;
int j;

  for (  i=r; i<mA->rows; i++)
    for (j=c; j<mA->cols; j++)
      *(mB->pb+(i-r) *mB->cols+(j-c)) = *(mA->pb+i *mA->cols+j);
}

