/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void    adjoint_mZ(
PmZ mCofactor,
PmZ mAdjoint)
{
  if (mCofactor->rows != mAdjoint->rows || mCofactor-> cols != mAdjoint->cols)
    {
     printf("\n adjoint() error - matrices different sizes");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

  transpose_mZ(mCofactor,mAdjoint);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inverse_mZ(
PmZ  mA,
PmZ  mInverse)
{
int      row;
int      n;
complexZ f;

MAT_TYPE pCofact[MXR][MXC*C2];mZ mCofact={MXR,MXC*C2,&pCofact[0][0]};

 n = mA->rows;
               mCofact.rows=n;
               mCofact.cols=n*C2;

     cofactor_mZ(mA,&mCofact);
      adjoint_mZ(   &mCofact,mInverse);
      f = det_Z(mA);
      f = inv_Z(f);

    for ( row = 0; row < mA->rows ; row++)
     {
        mul_r_Z(mInverse,row,f);
     }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inv_diag_mZ(
PmZ mA,
PmZ minvA,
MAT_TYPE e)
{
complexZ z;
int i;
int j;

  zeros_mZ(minvA);

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j+=C2)
       {

       if( (i*C2) == j)
         {
          z.r = (*(mA->pb+i *mA->cols+j   ));
          z.i = (*(mA->pb+i *mA->cols+j+C1));

          if( (z.r<e) && (z.i<e)) z = init_Z(0,0);
          else                    z = inv_Z(z);

          (*(minvA->pb+i *minvA->cols+j   ))=z.r;
          (*(minvA->pb+i *minvA->cols+j+C1))=z.i;
         }

       }
}

