/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ det_mOZ(
PmZ  mA
)
{
FILE *fp;
complexZ det;
   int i;
   int j;

mZ mdet ={1,1*C2,init_mZ(1,1*C2)};

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"      mdet  = det (a); \n\n");
  fprintf(fp,"ow_mz(mdet,\"adet.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(&mdet,"adet.dat");
  det.r = (*(mdet.pb+0 *mdet.cols+0));
  det.i = (*(mdet.pb+0 *mdet.cols+1));

  free(mdet.pb);

  return(det);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inverse_mOZ(
PmZ  mA,
PmZ  minvA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"inva=inverse(a);          \n\n");
  fprintf(fp,"ow_mz(inva,\"inva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(minvA,"inva.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void pinv_mOZ(
PmZ  mA,
PmZ  mpinvA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"pinvA=pinv(a);        \n\n");
  fprintf(fp,"ow_mz(pinvA,\"apinva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mpinvA,"apinva.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_sin_mOZ(
PmZ  mA,
PmZ  msinA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_sin_mz(a,\"asina.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(msinA,"asina.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_cos_mOZ(
PmZ  mA,
PmZ  mcosA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_cos_mz(a,\"acosa.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mcosA,"acosa.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_sinh_mOZ(
PmZ  mA,
PmZ  msinhA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_sinh_mz(a,\"asinha.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(msinhA,"asinha.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_cosh_mOZ(
PmZ  mA,
PmZ  mcoshA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_cosh_mz(a,\"acosha.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mcoshA,"acosha.dat");
}

