/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void leastsqrs_mZ(
PmZ mA,
PmZ mb,
PmZ mx
)
{
int A_r =mA->rows;
int A_c =mA->cols;

//MAT_TYPE pbAx    [MXR][MXC*C2];
//mZ mAx     ={MXR,MXC*C2,&pbAx    [0][0]};
//MAT_TYPE pTrpsA  [MXR][MXC*C2];
//mZ mTrpsA  ={MXR,MXC*C2,&pTrpsA  [0][0]};
//MAT_TYPE pTrpsA_A[MXR][MXC*C2];
//mZ mTrpsA_A={MXR,MXC*C2,&pTrpsA_A[0][0]};
//MAT_TYPE pTrpsA_b[MXR][MXC*C2];
//mZ mTrpsA_b={MXR,MXC*C2,&pTrpsA_b[0][0]};

//MAT_TYPE pAssNorSys[MXR][MXC*C2];
//mZ mAssNorSys ={MXR,MXC*C2,&pAssNorSys [0][0]};

mZ mAx;
mZ mTrpsA;
mZ mTrpsA_A;
mZ mTrpsA_b;
mZ mAssNorSys;



                    mAx.rows= A_r    ;         mAx.cols=         C2;
                 mTrpsA.rows=(A_c/C2);      mTrpsA.cols= A_r    *C2;
               mTrpsA_A.rows=(A_c/C2);    mTrpsA_A.cols=(A_c/C2)*C2;
               mTrpsA_b.rows=(A_c/C2);    mTrpsA_b.cols=         C2;
             mAssNorSys.rows=(A_c/C2);  mAssNorSys.cols= A_r    *C2;

			 mAx.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAx.rows*mAx.cols);
			 mTrpsA.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA.rows*mTrpsA.cols);
			 mTrpsA_A.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA_A.rows*mTrpsA_A.cols);
			 mTrpsA_b.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsA_b.rows*mTrpsA_b.cols);
			 mAssNorSys.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAssNorSys.rows*mAssNorSys.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
   ctranspose_mZ( mA,&mTrpsA);
       mul_mZ(&mTrpsA,mA,&mTrpsA_A);
       mul_mZ(&mTrpsA,mb,&mTrpsA_b);
       copy_mZ(&mTrpsA_A,&mAssNorSys);
     copy_c_Z(&mTrpsA_b,0,&mAssNorSys,(A_c/C2));
 gaussjordan_mZ(&mAssNorSys);
     copy_c_Z(&mAssNorSys,(A_c/C2),mx,0);


	 free(mAx.pB);
			 free(mTrpsA.pB);
			 free(mTrpsA_A.pB);
			 free(mTrpsA_b.pB);
			 free(mAssNorSys.pB);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void orthprojwb_mZ(
PmZ mA,
PmZ mb,
PmZ mprojwb
)
{
int  A_c = mA->cols;

//MAT_TYPE pbx[MXR][MXC*C2];
//mZ mx = {MXR,MXC*C2,&pbx[0][0]};

mZ mx;

            mx.rows=(A_c/C2);          mx.cols= C2;

			mx.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mx.rows*mx.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
    leastsqrs_mZ(mA, mb,&mx);
          mul_mZ(mA,&mx, mprojwb);

		  free(mx.pB);
}
