/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void copy_c_Z(
PmZ mA,
    int colA,
PmZ mB,
    int colB)
{
int i;

    for ( i=0; i<mA->rows; i++)
      {
       *(mB->pb+i *mB->cols+colB*C2  ) = *(mA->pb+i *mA->cols+colA*C2  );
       *(mB->pb+i *mB->cols+colB*C2+1) = *(mA->pb+i *mA->cols+colA*C2+1);
      }
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ copy_c_coeff_Z(
PmZ    A,
int colA)
{
int i;
complexZ coeff;

      coeff.r = *(A->pb+0 *A->cols+colA+0);
      coeff.i = *(A->pb+0 *A->cols+colA+1);
          i = 0;
      while(!coeff.r && !coeff.i && i<A->rows)
        {
         coeff.r = *(A->pb+i *A->cols+colA+0);
         coeff.i = *(A->pb+i *A->cols+colA+1);
         i++;
         printf("coeff = 0");
         getchar();
        }

       if(!coeff.r && !coeff.i)
         {
          printf("copy_c_coeff_Z() Error coeff = 0");
          exit(1);
         }
return(coeff);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ copy_c_coeffmax_Z(
PmZ    A,
int colA)
{
int      i;
MAT_TYPE   coeff;
complexZ coeffmax;

    p_mZ(A);

              coeff =  *(A->pb+0 *A->cols+colA+0);
         coeffmax.r =  *(A->pb+0 *A->cols+colA+0);
         coeffmax.i =  *(A->pb+0 *A->cols+colA+1);

    for( i=0; i<A->rows; i++)
       {

        if( fabs((*(A->pb+i *A->cols+colA+0))) > fabs(coeff))
        {
         coeff      = *(A->pb+i *A->cols+colA+0);
         coeffmax.r = *(A->pb+i *A->cols+colA+0);
         coeffmax.i = *(A->pb+i *A->cols+colA+1);
        }

        if( fabs((*(A->pb+i *A->cols+colA+1))) > fabs(coeff))
        {
         coeff      = *(A->pb+i *A->cols+colA+1);
         coeffmax.r = *(A->pb+i *A->cols+colA+0);
         coeffmax.i = *(A->pb+i *A->cols+colA+1);
        }

       }

    if(!coeffmax.r && !coeffmax.i)
      {
       printf("copy_c_coeffmax_Z() Error coeff = 0");
       exit(1);
      }

return(coeffmax);
}

