

#ifndef SET_H
#define SET_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct mySet_s
{
	int noOfElt;
	int *elt;
};

typedef struct mySet_s mySet;

mySet *mySet_new();
void mySet_insert(mySet *aSet, int eltNo);
void mySet_free(mySet *aSet);

int mySet_isExist(mySet *aSet, int aValue);
void mySet_insertNonRepeat(mySet *aSet, int aValue);
void mySet_unionNonRepeat(mySet *set1, mySet *set2);
int mySet_isOverlap(mySet *set1, mySet *set2);

int mySet_isEqual(mySet *aSet1, mySet *aSet2);
mySet *mySet_clone(mySet *aSet);

void mySet_removeIndex(mySet *aSet, int index);

#endif
